# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::PolicyInsights::Mgmt::V2019_10_01
  module Models
    #
    # Slim version of policy metadata resource definition, excluding properties
    # with large strings
    #
    class SlimPolicyMetadata

      include MsRestAzure

      # @return [String] The policy metadata identifier.
      attr_accessor :metadata_id

      # @return [String] The category of the policy metadata.
      attr_accessor :category

      # @return [String] The title of the policy metadata.
      attr_accessor :title

      # @return [String] The owner of the policy metadata.
      attr_accessor :owner

      # @return [String] Url for getting additional content about the resource
      # metadata.
      attr_accessor :additional_content_url

      # @return Additional metadata.
      attr_accessor :metadata

      # @return [String] The ID of the policy metadata.
      attr_accessor :id

      # @return [String] The type of the policy metadata.
      attr_accessor :type

      # @return [String] The name of the policy metadata.
      attr_accessor :name


      #
      # Mapper for SlimPolicyMetadata class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SlimPolicyMetadata',
          type: {
            name: 'Composite',
            class_name: 'SlimPolicyMetadata',
            model_properties: {
              metadata_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.metadataId',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.category',
                type: {
                  name: 'String'
                }
              },
              title: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.title',
                type: {
                  name: 'String'
                }
              },
              owner: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.owner',
                type: {
                  name: 'String'
                }
              },
              additional_content_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalContentUrl',
                type: {
                  name: 'String'
                }
              },
              metadata: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.metadata',
                type: {
                  name: 'Object'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
